package com.ggreiff.gel.tag.javascript;

/**
 * Created with IntelliJ IDEA.
 * User: ggreiff
 * Date: 8/19/14
 * Time: 3:35 PM
 */
public class JsValue {

    private String valueStr;
    private Number valueNumber;
    private Object valueObject;

    public static JsValue create(Object value) {
/*        if (value instanceof String) {
            return new JsValue((String) value);
        }

        if (value instanceof Number) {
            return new JsValue((Number) value);
        }*/
        return new JsValue(value);
    }

    private JsValue(String value) {
        valueStr = value;
    }

    private JsValue(Number value) {
        valueNumber = value;
    }

    private JsValue(Object value) {
        valueObject = value;
    }

    public String getString() {
        if (valueStr == null) {
            throw new IllegalStateException("This value is not an String");
        }
        return valueStr;
    }

    public boolean isString() {
        return valueStr != null;
    }

    public Number getNumber() {
        if (valueNumber == null) {
            throw new IllegalStateException("This value is not an Number");
        }
        return valueNumber;
    }


    public boolean isNumber() {
        return valueNumber != null;
    }

    public Object getValue() {
        if (isNumber()) {
            return valueNumber;
        } else if (isString()) {
            return valueStr;
        }
        return valueObject;
    }
}